## TODO: Document header
compute_probs <- function(data, quantiles,
                          ncores=1, quantile_dims=c('syear', 'ensemble'),
                          probs_dims=list('ensemble', 'bin'),
                          split_factor=1, na.rm=FALSE) {

  if (na.rm == FALSE) {
    c2p <- function(x, t) {
      # If the array contains any NA values, return NA
      if (any(is.na(x))) {
	rep(NA, dim(t)[['bin']] + 1)
      } else {
       colMeans(convert2prob(as.vector(x), threshold = as.vector(t)))
      }
    }
  } else {
    c2p <- function(x, t) {
      if (any(!is.na(x))) { # If the array contains some non-NA values
        colMeans(convert2prob(as.vector(x), threshold = as.vector(t)))
      } else { # If the array contains NAs only
	rep(NA, dim(t)[['bin']] + 1) # vector with as many NAs as prob bins.
      }
    }
  }
  
  probs <- Apply(data = list(x = data, t = quantiles),
                 target_dims = probs_dims,
                 c2p,
                 output_dims = "bin",
                 split_factor = split_factor,
                 ncores = ncores)[[1]]

  return(probs)
}     
